--- q931.c.orig	Fri Jun  4 13:13:45 2004
+++ q931.c	Fri Jun  4 13:20:02 2004
@@ -933,10 +933,15 @@
 
 static int transmit_display(struct pri *pri, q931_call *call, int msgtype, q931_ie *ie, int len)
 {
+	int i;
 	if ((pri->switchtype != PRI_SWITCH_NI1) && strlen(call->callername)) {
-		ie->data[0] = 0xb1;
-		memcpy(ie->data + 1, call->callername, strlen(call->callername));
-		return 3 + strlen(call->callername);
+		i = 0;
+		if(pri->switchtype != PRI_SWITCH_EUROISDN_E1) {
+			ie->data[0] = 0xb1;
+			++i;
+		}
+		memcpy(ie->data + i, call->callername, strlen(call->callername));
+		return 2 + i + strlen(call->callername);
 	}
 	return 0;
 }
